searchNodes=[{"doc":"This module provides the main API to interface with Acme.","ref":"Acmex.html","title":"Acmex","type":"module"},{"doc":"","ref":"Acmex.html#child_spec/1","title":"Acmex.child_spec/1","type":"function"},{"doc":"Finalizes the order. Parameters order: The order resource with status &quot;pending&quot;. Examples iex&gt; Acmex.finalize_order(%Order{status: &quot;pending&quot;}) {:ok, %Order{status: &quot;processing&quot;}}","ref":"Acmex.html#finalize_order/2","title":"Acmex.finalize_order/2","type":"function"},{"doc":"Gets an existing account. An account will only be returned if the current private key has been used to create a new account. Examples iex&gt; Acmex.get_account() {:ok, %Account{...}}","ref":"Acmex.html#get_account/0","title":"Acmex.get_account/0","type":"function"},{"doc":"Gets the certificate. The format of the certificate is application/pem-certificate-chain. Parameters order: The order resource with status &quot;valid&quot;. Examples iex&gt; Acmex.get_certificate(%Order{status: &quot;valid&quot;}) {:ok, &quot;-----BEGIN CERTIFICATE-----...&quot;}","ref":"Acmex.html#get_certificate/1","title":"Acmex.get_certificate/1","type":"function"},{"doc":"Gets an existing challenge. Parameters url: The url attribute of the challenge resource. Examples iex&gt; Acmex.get_challenge(%Challenge{...}.url) {:ok, %Challenge{...}}","ref":"Acmex.html#get_challenge/1","title":"Acmex.get_challenge/1","type":"function"},{"doc":"Gets the challenge response. Parameters challenge: The challenge resource. Examples iex&gt; Acmex.get_challenge_response(%Challenge{token: &quot;bZxymov025OYA4DkGSI5XPKdAW9V93eKoDZZ56AC3cI&quot;, type: &quot;dns-01&quot;}) {:ok, %{ key_authorization: &quot;AgemQZ-WIft7VwWljRb3l_nkyigEILfRzzx5E6HdFyY&quot;, record_name: &quot;_acme-challenge&quot;, record_type: &quot;TXT&quot; }} iex&gt; Acmex.get_challenge_response(%Challenge{token: &quot;oR3Xwj4GgXIxUtKMUfmVf4hmRFehAIgSsg7oXD_PCEw&quot;, type: &quot;http-01&quot;}) {:ok, %{ content_type: &quot;text/plain&quot;, filename: &quot;.well-known/acme-challenge/oR3Xwj4GgXIxUtKMUfmVf4hmRFehAIgSsg7oXD_PCEw&quot;, key_authorization: &quot;oR3Xwj4GgXIxUtKMUfmVf4hmRFehAIgSsg7oXD_PCEw.5zmJUVWaucybUNJSLeCaO9D_cauS5QiwA92KTiY_vNc&quot; }}","ref":"Acmex.html#get_challenge_response/1","title":"Acmex.get_challenge_response/1","type":"function"},{"doc":"Gets an existing order. Parameters url: The url attribute of the order resource. Examples iex&gt; Acmex.get_order(%{Order}.url) {:ok, %Order{...}}","ref":"Acmex.html#get_order/1","title":"Acmex.get_order/1","type":"function"},{"doc":"Creates a new account. Parameters contact: A list of URLs that the ACME can use to contact the client for issues related to this account. tos: Terms Of Service Agreed indicates the client&#39;s agreement with the terms of service. Examples iex&gt; Acmex.new_account([&quot;mailto:info@example.com&quot;], true) {:ok, %Account{...}}","ref":"Acmex.html#new_account/2","title":"Acmex.new_account/2","type":"function"},{"doc":"Creates a new order. Parameters identifiers: A list of domains. Examples iex&gt; Acmex.new_order([&quot;example.com&quot;]) {:ok, %Order{...}}","ref":"Acmex.html#new_order/1","title":"Acmex.new_order/1","type":"function"},{"doc":"Revokes a certificate. Parameters certificate: The certificate to be revoked. reason: Optional revocation reason code. Examples iex&gt; Acmex.revoke_certificate(&quot;-----BEGIN CERTIFICATE-----...&quot;, 0) :ok","ref":"Acmex.html#revoke_certificate/2","title":"Acmex.revoke_certificate/2","type":"function"},{"doc":"Starts the client with a private key. If the private key path does not exists, the client will not start. Parameters keyfile: The path to an RSA key. name: Optional name for the Client. Examples iex&gt; Acmex.start_link(keyfile: &quot;test/support/fixture/account.key&quot;) {:ok, #PID&lt;...&gt;} iex&gt; Acmex.start_link(key: &quot;-----BEGIN RSA PRIVATE KEY-----...&quot;, name: :acmex_optional_name) {:ok, #PID&lt;...&gt;}","ref":"Acmex.html#start_link/1","title":"Acmex.start_link/1","type":"function"},{"doc":"Validates the challenge. Parameters challenge: The challenge resource. Examples iex&gt; Acmex.validate_challenge(%Challenge{...}) {:ok, %Challenge{...}}","ref":"Acmex.html#validate_challenge/1","title":"Acmex.validate_challenge/1","type":"function"},{"doc":"","ref":"Acmex.html#t:account_reply/0","title":"Acmex.account_reply/0","type":"type"},{"doc":"","ref":"Acmex.html#t:certificate_reply/0","title":"Acmex.certificate_reply/0","type":"type"},{"doc":"","ref":"Acmex.html#t:certificate_revocation_reply/0","title":"Acmex.certificate_revocation_reply/0","type":"type"},{"doc":"","ref":"Acmex.html#t:challenge_reply/0","title":"Acmex.challenge_reply/0","type":"type"},{"doc":"","ref":"Acmex.html#t:on_start_link/0","title":"Acmex.on_start_link/0","type":"type"},{"doc":"","ref":"Acmex.html#t:order_reply/0","title":"Acmex.order_reply/0","type":"type"},{"doc":"This module is responsible for calling the ACME API. GenServer is used to store the account and its credentials.","ref":"Acmex.Client.html","title":"Acmex.Client","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Acmex.Client.html#child_spec/1","title":"Acmex.Client.child_spec/1","type":"function"},{"doc":"Starts the GenServer with a given account key.","ref":"Acmex.Client.html#start_link/2","title":"Acmex.Client.start_link/2","type":"function"},{"doc":"This module is responsible for getting the application configuration.","ref":"Acmex.Config.html","title":"Acmex.Config","type":"module"},{"doc":"Returns the directory URL from the application configuration.","ref":"Acmex.Config.html#directory_url/0","title":"Acmex.Config.directory_url/0","type":"function"},{"doc":"This module is responsible for providing functions to deal with JWK and JWS.","ref":"Acmex.Crypto.html","title":"Acmex.Crypto","type":"module"},{"doc":"Builds a JWK map from an account key.","ref":"Acmex.Crypto.html#fetch_jwk_from_key/1","title":"Acmex.Crypto.fetch_jwk_from_key/1","type":"function"},{"doc":"Signs a payload.","ref":"Acmex.Crypto.html#sign/3","title":"Acmex.Crypto.sign/3","type":"function"},{"doc":"This module provides functions to generate a Private Key and Certificate Signing Request.","ref":"Acmex.OpenSSL.html","title":"Acmex.OpenSSL","type":"module"},{"doc":"Generates a Certificate Signing Request. Parameters key_path: Private key path. domains: List of domains. subject: Subject attributes. Examples iex&gt; subject = %{organization_name: &quot;Example&quot;} iex&gt; Acmex.OpenSSL.generate_csr(&quot;-----BEGIN RSA PRIVATE KEY-----...&quot;, [&quot;example.com&quot;], subject) {:ok, &lt;&lt;48, 130, 2, 91, 48, 1, ...&gt;&gt;}","ref":"Acmex.OpenSSL.html#generate_csr/3","title":"Acmex.OpenSSL.generate_csr/3","type":"function"},{"doc":"Generates a RSA private key. Parameters type: Private key type. size: Private key size. Examples iex&gt; Acmex.OpenSSL.generate_key(:rsa, 2048) &quot;-----BEGIN RSA PRIVATE KEY-----...&quot;","ref":"Acmex.OpenSSL.html#generate_key/2","title":"Acmex.OpenSSL.generate_key/2","type":"function"},{"doc":"","ref":"Acmex.OpenSSL.html#t:rsa_key_sizes/0","title":"Acmex.OpenSSL.rsa_key_sizes/0","type":"type"},{"doc":"This module is responsible for requesting the ACME API.","ref":"Acmex.Request.html","title":"Acmex.Request","type":"module"},{"doc":"Makes a GET request to fetch an unauthenticated resource.","ref":"Acmex.Request.html#get/3","title":"Acmex.Request.get/3","type":"function"},{"doc":"Gets a header by a given key.","ref":"Acmex.Request.html#get_header/2","title":"Acmex.Request.get_header/2","type":"function"},{"doc":"Makes a HEAD request to an URL.","ref":"Acmex.Request.html#head/1","title":"Acmex.Request.head/1","type":"function"},{"doc":"Makes a POST request.","ref":"Acmex.Request.html#post/5","title":"Acmex.Request.post/5","type":"function"},{"doc":"Makes a POST request to fetch an authenticated resource.","ref":"Acmex.Request.html#post_as_get/5","title":"Acmex.Request.post_as_get/5","type":"function"},{"doc":"","ref":"Acmex.Request.html#t:response/0","title":"Acmex.Request.response/0","type":"type"},{"doc":"This structure represents an account.","ref":"Acmex.Resource.Account.html","title":"Acmex.Resource.Account","type":"module"},{"doc":"Builds an account.","ref":"Acmex.Resource.Account.html#new/1","title":"Acmex.Resource.Account.new/1","type":"function"},{"doc":"","ref":"Acmex.Resource.Account.html#t:t/0","title":"Acmex.Resource.Account.t/0","type":"type"},{"doc":"This structure represents an authorization for an account.","ref":"Acmex.Resource.Authorization.html","title":"Acmex.Resource.Authorization","type":"module"},{"doc":"Returns the DNS challenge from an authorization.","ref":"Acmex.Resource.Authorization.html#dns/1","title":"Acmex.Resource.Authorization.dns/1","type":"function"},{"doc":"Returns the HTTP challenge from an authorization.","ref":"Acmex.Resource.Authorization.html#http/1","title":"Acmex.Resource.Authorization.http/1","type":"function"},{"doc":"Builds an authorization struct.","ref":"Acmex.Resource.Authorization.html#new/1","title":"Acmex.Resource.Authorization.new/1","type":"function"},{"doc":"","ref":"Acmex.Resource.Authorization.html#t:t/0","title":"Acmex.Resource.Authorization.t/0","type":"type"},{"doc":"This structure represents a challenge to prove control of an identifier.","ref":"Acmex.Resource.Challenge.html","title":"Acmex.Resource.Challenge","type":"module"},{"doc":"Gets the key authorization from a challenge and JWK.","ref":"Acmex.Resource.Challenge.html#get_key_authorization/2","title":"Acmex.Resource.Challenge.get_key_authorization/2","type":"function"},{"doc":"Gets the response from a challenge.","ref":"Acmex.Resource.Challenge.html#get_response/2","title":"Acmex.Resource.Challenge.get_response/2","type":"function"},{"doc":"Builds a challenge struct.","ref":"Acmex.Resource.Challenge.html#new/1","title":"Acmex.Resource.Challenge.new/1","type":"function"},{"doc":"","ref":"Acmex.Resource.Challenge.html#t:dns_response/0","title":"Acmex.Resource.Challenge.dns_response/0","type":"type"},{"doc":"","ref":"Acmex.Resource.Challenge.html#t:http_response/0","title":"Acmex.Resource.Challenge.http_response/0","type":"type"},{"doc":"","ref":"Acmex.Resource.Challenge.html#t:t/0","title":"Acmex.Resource.Challenge.t/0","type":"type"},{"doc":"This structure represents a directory.","ref":"Acmex.Resource.Directory.html","title":"Acmex.Resource.Directory","type":"module"},{"doc":"Builds a directory struct.","ref":"Acmex.Resource.Directory.html#new/1","title":"Acmex.Resource.Directory.new/1","type":"function"},{"doc":"","ref":"Acmex.Resource.Directory.html#t:t/0","title":"Acmex.Resource.Directory.t/0","type":"type"},{"doc":"This structure represents a client request for a certificate.","ref":"Acmex.Resource.Order.html","title":"Acmex.Resource.Order","type":"module"},{"doc":"Builds an order struct.","ref":"Acmex.Resource.Order.html#new/2","title":"Acmex.Resource.Order.new/2","type":"function"},{"doc":"","ref":"Acmex.Resource.Order.html#t:t/0","title":"Acmex.Resource.Order.t/0","type":"type"},{"doc":"Acmex Acmex is an Elixir Client for the Lets Encrypt ACMEv2 protocol.","ref":"readme.html","title":"Acmex","type":"extras"},{"doc":"The package can be installed by adding acmex to your list of dependencies in mix.exs: def deps do [ {:acmex, &quot;~&gt; 0.1.2&quot;} ] end","ref":"readme.html#installation","title":"Acmex - Installation","type":"extras"},{"doc":"Set the directory_url in your config.exs: config :acmex, directory_url: &quot;https://acme-v02.api.letsencrypt.org/directory&quot; If you need a staging version of Lets Encrypt ACMEv2 set the directory_url as https://acme-staging-v02.api.letsencrypt.org/directory.","ref":"readme.html#configure","title":"Acmex - Configure","type":"extras"},{"doc":"Client Starting the client You need to generate a private key to start the client. Acmex actually expects a RSA Key. If you don&#39;t have it, you can create one through Acmex: key = Acmex.OpenSSL.generate_key(:rsa) And now start the client with the generated key: Acmex.start_link(key: key) To use on your supervisor: children = [ {Acmex, [[key: &quot;-----BEGIN RSA PRIVATE KEY-----...&quot;]]} ] Account Creating a new account The second parameter is about the agreement of the terms of service. Acmex.new_account([&quot;mailto:info@example.com&quot;], true) Fetch existing account Acmex.get_account() Order Creating a new order Acmex.new_order([&quot;example.com&quot;]) Fetch an existing order Acmex.get_order(order.url) Challenge Receive a challenge authorization = List.first(order.authorizations) challenge = Acmex.Resource.Authorization.http(authorization) Return a challenge response Acmex.get_challenge_response(challenge) Validate the challenge {:ok, challenge} = Acmex.validate_challenge(challenge) Fetch an existing challenge Acmex.get_challenge(challenge.url) Certificate Finalize an order order_key = Acmex.OpenSSL.generate_key(:rsa) {:ok, csr} = Acmex.OpenSSL.generate_csr(order_key, [&quot;example.com&quot;]) {:ok, order} = Acmex.finalize_order(order, csr) Get the certificate Acmex.get_certificate(order) Revoke a certificate {:ok, certificate} = Acmex.get_certificate(order) Acmex.revoke_certificate(certificate, 0)","ref":"readme.html#usage","title":"Acmex - Usage","type":"extras"},{"doc":"The full documentation can be found at https://hexdocs.pm/acmex.","ref":"readme.html#documentation","title":"Acmex - Documentation","type":"extras"},{"doc":"To run the tests you need an ACME Test Server. You can use Pebble. For this reason, there is a docker-compose.yml file with pebble defined as a service. To use pebble and run the tests: $ docker-compose up $ mix test","ref":"readme.html#contributing","title":"Acmex - Contributing","type":"extras"},{"doc":"MIT License Copyright (c) 2020 Sérgio Rodrigues Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"readme.html#license","title":"Acmex - License","type":"extras"},{"doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog, and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Changed Improve the documentation. Fixed Avoid to start Acmex when the key is invalid. An error should be returned.","ref":"changelog.html#0-1-2-2020-05-03","title":"Changelog - 0.1.2 - 2020-05-03","type":"extras"},{"doc":"Changed Update dependencies.","ref":"changelog.html#0-1-1-2020-04-26","title":"Changelog - 0.1.1 - 2020-04-26","type":"extras"},{"doc":"Added Add ACME v2 main functions.","ref":"changelog.html#0-1-0-2019-12-07","title":"Changelog - 0.1.0 - 2019-12-07","type":"extras"}]